const express = require('express')
const sqlite3 = require('sqlite3').verbose()
const morgan = require('morgan')
const fs = require('fs')

const db = new sqlite3.Database(':memory:')

const app = express()
app.use(morgan('common'))
app.use('/static', express.static('static'))
app.set('view engine', 'pug')

const port = 3000

app.get('/', (req, res) => {
	if(!req.query.query) {
		res.render('index')
		return
	}
	if(req.query.query.length < 2) {
		res.render('index', {msg: "Search query too short!", query: req.query.query})
		return
	}
	db.all("SELECT * FROM internet_index WHERE title LIKE '%' || ? || '%' and is_secret = ?", req.query.query, 0, (err, rows) => {
		if(err) {
			console.log(err)
			res.render('index', {msg: err})
			return
		}
		res.render('index', {items: rows, query: req.query.query})
	})
})

fs.readFile("flag.txt", 'utf8', (err, data) => {
	flag = data.trim()
	console.log(`Flag: ${flag}`)

	db.serialize(() => {
		db.run("CREATE TABLE internet_index (id INT PRIMARY KEY, title TEXT, url TEXT, is_secret INT)")
		db.run("INSERT INTO internet_index VALUES (NULL, 'Chair for IT Security', 'https://sec.in.tum.de/', 0)")
		db.run("INSERT INTO internet_index VALUES (NULL, 'Technical University of Munich (TUM)', 'https://www.tum.de/', 0)")
		db.run("INSERT INTO internet_index VALUES (NULL, 'Heise', 'https://www.heise.de', 0)")
		db.run("INSERT INTO internet_index VALUES (NULL, 'Golem', 'https://www.golem.de', 0)")
		db.run("INSERT INTO internet_index VALUES (NULL, 'TUM Moodle', 'https://moodle.tum.de', 0)")
		db.run("INSERT INTO internet_index VALUES (NULL, 'TUMonline', 'https://campus.tum.de', 0)")
		db.run("INSERT INTO internet_index VALUES (NULL, 'Wikipedia', 'https://www.wikipedia.com', 0)")
		db.run("INSERT INTO internet_index VALUES (NULL, 'Stiftung Warentest', 'https://www.test.de', 0)")
		db.run("INSERT INTO internet_index VALUES (NULL, 'flag', ?, 1)", flag)
	})

	app.listen(port, () => {
	  console.log(`WebSec SS2024 - Qualification Task running on port ${port}`)
	})
})
